//////////////////////////////////////////////////////////////////////
//
//   Kenny Translator in Go
//   by Kohan Ikin (aka SyneRyder)
//   v1.00  //  6 April 2012
//
//   web:     http://www.namesuppressed.com/kenny/
//   email:   syneryder@namesuppressed.com
//   twitter: @syneryder
//
//
//   LICENSE
//
//   Copyright (c) 2012 namesuppressed.  All rights reserved.
//
//   Redistribution and use in source and binary forms, with or without
//   modification, are permitted provided that the following conditions
//   are met:
//
//   * Redistributions of source code must retain the above copyright
//     notice, this list of conditions and the following disclaimer.
//
//   * Neither the name of namesuppressed nor the names of the
//     contributors may be used to endorse or promote products derived
//     from this software without specific prior written permission.
//
//   * A website link to http://www.namesuppressed.com/kenny/ is
//     greatly appreciated, although not required.
//
//   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//   FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
//   COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
//   INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
//   BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
//   CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
//   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
//   ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
//   POSSIBILITY OF SUCH DAMAGE.
//
//
//   VERSION HISTORY
//
//   1.00a1 2012.04.06  First Release
//
//
//   CREDITS
//
//   Concept by Greg Howell, Kohan Ikin and Nigel King.  South Park
//   is a registered trademark of Comedy Central. South Park created
//   by Trey Parker and Matt Stone. The Kenny Translator is not
//   affiliated with Comedy Central.
//
//////////////////////////////////////////////////////////////////////



package main

import (
	"fmt";
	"strings";
	"os";
)



func isKennyspeak(s string) bool {
  // All non-kenny letters (in English, anyway)
  return !strings.ContainsAny(s, "abcdeghijklnoqrstuvwxyzABCDEGHIJKLNOQRSTUVWXYZ");
}


func kennify(s string) string {

  // Easter eggs
  if (s == "greggles is a steggles") { return "oh yes he is" }
  if (s == "hellokohan") { return "fittzuzfa!" }
  if (s == "ik!")        { return "\"ik!\" is not an easter egg." }
  if (s == "ik")         { return "\"ik\" was Simon's idea, not mine!" }
  if (s == "ingy")       { return "\"Sad eggs....\"\n\n- Ingy\nwww.ingy.net" }
  if (s == "CS302")      { return "Pat Quincy Upbottom" }
  if (s == "Aeolas")     { return "Aeolas thinks KennySpeak sounds like " +
                            "someone getting head....\n\n" +
                            "http://pub28.ezboard.com/ftweetysnestofr" +
                            "eaksfrm1.showMessage?topicID=701.topic"}

  if (!isKennyspeak(s)) {
    r := strings.NewReplacer("e", "mpp",
                             "t", "fmp",
                             "a", "mmm",
                             "o", "ppf",
                             "i", "mff",
                             "n", "ppp",
                             "s", "fmm",
                             "h", "mfp",
                             "r", "pff",
                             "d", "mpm",
                             "l", "pmf",
                             "c", "mmf",
                             "u", "fmf",
                             "m", "ppm",
                             "w", "fpp",
                             "f", "mpf",
                             "g", "mfm",
                             "y", "ffm",
                             "p", "pfm",
                             "b", "mmp",
                             "v", "fpm",
                             "k", "pmp",
                             "j", "pmm",
                             "x", "fpf",
                             "q", "pfp",
                             "z", "ffp",
                             "E", "Mpp",
                             "T", "Fmp",
                             "A", "Mmm",
                             "O", "Ppf",
                             "I", "Mff",
                             "N", "Ppp",
                             "S", "Fmm",
                             "H", "Mfp",
                             "R", "Pff",
                             "D", "Mpm",
                             "L", "Pmf",
                             "C", "Mmf",
                             "U", "Fmf",
                             "M", "Ppm",
                             "W", "Fpp",
                             "F", "Mpf",
                             "G", "Mfm",
                             "Y", "Ffm",
                             "P", "Pfm",
                             "B", "Mmp",
                             "V", "Fpm",
                             "K", "Pmp",
                             "J", "Pmm",
                             "X", "Fpf",
                             "Q", "Pfp",
                             "Z", "Ffp")
    return r.Replace(s);
  } else {
    r := strings.NewReplacer("mpp", "e", 
                             "fmp", "t",
                             "mmm", "a",
                             "ppf", "o",
                             "mff", "i", 
                             "ppp", "n",
                             "fmm", "s",
                             "mfp", "h",
                             "pff", "r",
                             "mpm", "d",
                             "pmf", "l",
                             "mmf", "c",
                             "fmf", "u",
                             "ppm", "m",
                             "fpp", "w",
                             "mpf", "f",
                             "mfm", "g",
                             "ffm", "y",
                             "pfm", "p",
                             "mmp", "b",
                             "fpm", "v",
                             "pmp", "k",
                             "pmm", "j",
                             "fpf", "x",
                             "pfp", "q",
                             "ffp", "z",
                             "Mpp", "E",
                             "Fmp", "T", 
                             "Mmm", "A",
                             "Ppf", "O", 
                             "Mff", "I", 
                             "Ppp", "N", 
                             "Fmm", "S", 
                             "Mfp", "H", 
                             "Pff", "R", 
                             "Mpm", "D", 
                             "Pmf", "L", 
                             "Mmf", "C", 
                             "Fmf", "U", 
                             "Ppm", "M", 
                             "Fpp", "W", 
                             "Mpf", "F", 
                             "Mfm", "G", 
                             "Ffm", "Y", 
                             "Pfm", "P", 
                             "Mmp", "B", 
                             "Fpm", "V", 
                             "Pmp", "K", 
                             "Pmm", "J", 
                             "Fpf", "X", 
                             "Pfp", "Q", 
                             "Ffp", "Z")
    return r.Replace(s);
  }

  // Never reached, required for compiler
  return "";
}



func main() {
    if (len(os.Args) < 2) {
      fmt.Println("Usage: kenny <sentence to kennify>")
    } else {
      var userinput string = strings.Join(os.Args[1:len(os.Args)], " ")
      fmt.Println(kennify(userinput))
    }
}
